#include <stdio.h>  // printf, scanf

int main()
{
    // variveis do tipo contador (usadas para percorrer os elementos da matriz)
    int i, j;

    // variveis que armzenam o tamanho da matriz
    int linhas, colunas;

    // variveis utilizadas no clculo
    int qtde_1=0, qtde_0=0;

    // 1. Pedir para a pessoa informar o tamanho da matriz (linhas e colunas)
    // O lao de repetio DO-WHILE  utilizado para validar os dados de entrada
    do
    {
        printf("Informe o tamanho da matriz (n x n): ");
        scanf("%d x %d", &linhas, &colunas);

        if((linhas != colunas) || (linhas < 2) || (colunas < 2))
        {
            printf("\nInforme o tamanho de uma matriz quadrada cuja linha e coluna seja maior que 1.\n\n");
        }
    }
    while((linhas != colunas) || (linhas < 2) || (colunas < 2));

    // 2. Declarar uma matriz do tipo inteiro a partir dos dados fornecidos;
    int Mi[linhas][colunas];

    // 3. Ler os dados da matriz e armazenar os mesmos em suas respectivas posies;
    for(i=0; i<linhas; i++)
    {
        for(j=0; j<colunas; j++)
        {
            printf("Informe o elemento da matriz da linha %i e coluna %i: ", i, j);
            scanf("%d*%c", &Mi[i][j]);
        }
    }

    printf("\n****** Elementos da Matriz ******\n\n");

    // 4. Apresentar os elementos da matriz;
    for(i=0; i<linhas; i++)
    {
        for(j=0; j<colunas; j++)
        {
            printf("[%d] ", Mi[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    // 5. Percorrer a matriz do incio ao fim verificando se a diagonal principal possui apenas valores iguais a 1 e se os demais elementos so 0;
    for(i=0; i<linhas; i++)
    {
        for(j=0; j<colunas; j++)
        {
            // Sabe-se que o elemento pertence a diagonal da matriz quando a linha for igual a coluna onde este foi armazenado.
            if((i == j) && Mi[i][j] == 1)
            {
                qtde_1++;
            }
            else
            {
                if(Mi[i][j] == 0)
                {
                    qtde_0++;
                }
            }
        }
    }

    // 7. Se a quantidade de nmeros 1 (um) for igual ao tamanho de qualquer uma das dimenses da matriz e o nmero de valores
    //    iguais a 0 (zero) for igual ao total de elementos da matriz menos a quantidade calculada anteriormente, ento ela  uma matriz identidade;
    if((qtde_1 == linhas) && (qtde_0 == ((linhas * colunas) - qtde_1)))
        printf("\nA matriz informada EH classificada como MATRIZ IDENTIDADE.\n");
    else
        printf("\nA matriz informada NAO EH uma MATRIZ IDENTIDADE.\n");

    return 0;
}
