#include <stdio.h> // printf, scanf

int main()
{
    // variveis do tipo contador (usadas para percorrer os elementos da matriz)
    int i, j;

    // variveis que armzenam o tamanho da matriz
    int linhas, colunas;

    // 1. Pedir para a pessoa informar o tamanho da matriz (linhas e colunas)
    // O lao de repetio DO-WHILE  utilizado para validar os dados de entrada
    do
    {
        printf("Informe o tamanho da matriz (m x n): ");
        scanf("%d x %d", &linhas, &colunas);

        if((linhas < 1) || (colunas < 1))
        {
            printf("\nInforme o tamanho de uma matriz cuja linha e coluna seja maior que 0.\n\n");
        }
    }
    while((linhas < 1) || (colunas < 1));

    // 2. Declarar uma matriz do tipo inteiro a partir dos dados fornecidos;
    int M[linhas][colunas];

    // Declara uma varivel para armazenar a matriz transposta
    int Mt[colunas][linhas];

    // 3. Ler os dados da matriz e armazenar os mesmos em suas respectivas posies;
    for(i=0; i<linhas; i++)
    {
        for(j=0; j<colunas; j++)
        {
            printf("Informe o elemento da matriz da linha %d e coluna %d: ", i, j);
            scanf("%d*%c", &M[i][j]);
        }
    }

    printf("\n****** Elementos da Matriz ******\n\n");

    // 4. Apresentar os elementos da matriz;
    for(i=0; i<linhas; i++)
    {
        for(j=0; j<colunas; j++)
        {
            printf("[%d]", M[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    // 5. Percorrer a matriz do incio ao fim trocando o elemento que est na linha da matriz pela coluna da mesma;
    for(i=0; i<linhas; i++)
    {
        // 6. Para simplificar o processamento basta trocar os ndices da matriz quando estiver percorrendo a mesma e
        // colocar o elemento na matriz transposta invertendo os ndices;
        for(j=0; j<colunas; j++)
        {
            Mt[j][i] = M[i][j];
        }
    }

    // 7. Apresentar os elementos da matriz transposta.
    printf("\n****** Elementos da Matriz Transposta ******\n\n");

    for(i=0; i<colunas; i++)
    {
        for(j=0; j<linhas; j++)
        {
            printf("[%d]", Mt[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    return 0;
}

