#include <stdio.h>  // printf, scanf

int main()
{
    // variveis do tipo contador (usadas para percorrer os elementos da matriz)
    int i, j, k;

    // variveis que armzenam o tamanho da matriz
    int m, n1, n2, p;

    // variveis auxiliares
    int soma=0, mult;

    // 1. Pedir para a pessoa informar o tamanho da matriz A (linhas e colunas)
    // O lao de repetio DO-WHILE  utilizado para validar os dados de entrada
    do
    {
        printf("Informe o tamanho da matriz A (m x n): ");
        scanf("%i x %i", &m, &n1);

        if((m < 1) || (n1 < 1))
        {
            printf("\nInforme o tamanho de uma matriz cuja linha e coluna seja maior que 0.\n\n");
        }
    }
    while((m < 1) || (n1 < 1));

    // 2. Pedir para a pessoa informar o tamanho da matriz B (linhas e colunas)
    // O lao de repetio DO-WHILE  utilizado para validar os dados de entrada
    do
    {
        printf("Informe o tamanho da matriz B (n x p): ");
        scanf("%i x %i", &n2, &p);

        if((n2 < 1) || (p < 1))
        {
            printf("\nInforme o tamanho de uma matriz cuja linha e coluna seja maior que 0.\n\n");
        }

        if((n1 != n2))
        {
            printf("\nO numero de linhas da matriz B deve ser igual ao numero de colunas da matriz A.\n\n");
        }
    }
    while((n2 < 1) || (p < 1) || (n1 != n2));

    // 3. Declarar as matrizes com os valores informados e uma terceira matriz para armazenar a multiplicao das mesmas
    int A[m][n1], B[p][n2], R[m][p];

    // 4. Ler os dados da primeira matriz (A) e armazenar os mesmos em suas respectivas posies;
    for(i=0; i<m; i++)
    {
        for(j=0; j<n1; j++)
        {
            printf("Informe o elemento da matriz A da linha %i e coluna %i: ", i, j);
            scanf("%i*%c", &A[i][j]);
        }
    }

    // 5. Ler os dados da segunda matriz (B) e armazenar os mesmos em suas respectivas posies;
    for(i=0; i<n2; i++)
    {
        for(j=0; j<p; j++)
        {
            printf("Informe o elemento da matriz B da linha %i e coluna %i: ", i, j);
            scanf("%i*%c", &B[i][j]);
        }
    }

    printf("\n****** Elementos da Matriz A ******\n\n");

    // 6. Apresentar os elementos da matriz A;
    for(i=0; i<m; i++)
    {
        for(j=0; j<n1; j++)
        {
            printf("[%i] ", A[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    printf("\n****** Elementos da Matriz B ******\n\n");

    // 7. Apresentar os elementos da matriz B;
    for(i=0; i<n2; i++)
    {
        for(j=0; j<p; j++)
        {
            printf("[%i] ", B[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    // 8. Percorrer a matriz A e B calculando o elemento resultante da multiplicao de suas linhas e colunas
    for(i=0; i<m; i++)
    {
        for(k=0; k<p; k++)
        {
            for(j=0; j<n1; j++)
            {
                mult = A[i][j] * B[j][k];

                //printf("A[%d][%d] * B[%d][%d] = %d\n", i, j, j, k, mult);

                soma = soma + mult;
            }

            //printf("\n");
            R[i][k] = soma;
            soma = 0;
        }
    }

    printf("\n****** Elementos da Matriz R ******\n\n");

    // 9. Apresentar os elementos da matriz resultante;
    for(i=0; i<m; i++)
    {
        for(j=0; j<p; j++)
        {
            printf("[%2i] ", R[i][j]);
        }

        // a cada linha da matriz pula uma linha na tela
        printf("\n");
    }

    return 0;
}
